'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jsrsasign = require('jsrsasign');

var _jsrsasign2 = _interopRequireDefault(_jsrsasign);

var _Encrypt = require('./Encrypt');

var _Encrypt2 = _interopRequireDefault(_Encrypt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Issuer = function () {
	function Issuer(jwt) {
		_classCallCheck(this, Issuer);

		this.jwt = jwt;
	}

	_createClass(Issuer, [{
		key: 'isValid',
		value: function isValid(token) {
			return _jsrsasign2.default.jws.JWS.verify(this.jwt, { rstr: token }, ["HS256"]);
		}
	}, {
		key: 'username',
		get: function get() {
			var obj = _jsrsasign2.default.jws.JWS.parse(this.jwt);
			return obj.payloadObj.iss;
		}
	}, {
		key: 'options',
		get: function get() {
			var obj = _jsrsasign2.default.jws.JWS.parse(this.jwt);
			return obj.payloadObj.opt;
		}
	}, {
		key: 'dif',
		get: function get() {
			var obj = _jsrsasign2.default.jws.JWS.parse(this.jwt);
			return obj.payloadObj.dif;
		}
	}, {
		key: 'value',
		get: function get() {
			return this.jwt;
		}
	}], [{
		key: 'generate',
		value: function generate(key, options, token) {
			var oHeader = { alg: "HS256", typ: "JWT" };
			var oPayload = {};

			oPayload.iss = key.username;
			oPayload.opt = opt;

			var sHeader = JSON.stringify(oHeader);
			var sPayload = JSON.stringify(oPayload);

			return new Issuer(_jsrsasign2.default.jws.JWS.sign(oHeader.alg, sHeader, sPayload, { rstr: token }));
		}
	}]);

	return Issuer;
}();

exports.default = Issuer;